#
# _CGIHTTPServer.py - Tiny HTTP server supporting CGI.
# Copyright (C) 2005  shinGETsu Project.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: _CGIHTTPServer.py,v 1.13 2005/03/13 15:13:55 fuktommy Exp $
#

import os
import re
import sys
import BaseHTTPServer
import CGIHTTPServer
import SocketServer

__version__ = "$Revision: 1.13 $"

class HTTPRequestHandler(CGIHTTPServer.CGIHTTPRequestHandler):

    """Tiny HTTP Server.

    Exec CGI if script name ends with .cgi.
    """

    root_index = "/"

    def is_cgi(self):
        """Test request URI is *.cgi."""
        found = re.search(r"^(.*?)/([^/]+\.cgi.*)", self.path)
        if found:
            self.cgi_info = found.groups()
            return True
        else:
            return False

    def _is_python(self, path):
        """All CGI script is Python script."""
        return path.endswith(".cgi")

    if hasattr(sys, "winver"):
        is_python = _is_python

    def common(self):
        if self.path == "/":
            self.path = self.root_index
        os.environ["HTTP_ACCEPT_LANGUAGE"] = \
            self.headers.get("Accept-Language", "")
        os.environ["HTTP_HOST"] = self.headers.getheader('host')

    def do_POST(self):
        self.common()
        return CGIHTTPServer.CGIHTTPRequestHandler.do_POST(self)

    def send_head(self):
        self.common()
        return CGIHTTPServer.CGIHTTPRequestHandler.send_head(self)

    def log_request(self, code='-', size='-'):
        self.log_message('%s<>%s<>%s',
                         self.requestline, 
                         self.headers.get("Referer", ""),
                         self.headers.get("User-Agent", ""))

    def log_message(self, format, *args):
        sys.stderr.write("%s<>%s<>%s\n" %
                         (self.address_string(),
                          self.log_date_time_string(),
                          format%args))


class HTTPServer(SocketServer.ThreadingMixIn, BaseHTTPServer.HTTPServer):
    pass

def test(HandlerClass=None, ServerClass=None, port = 8000):
    import SimpleHTTPServer
    if HandlerClass is None:
        HandlerClass = HTTPRequestHandler
    if ServerClass is None:
        ServerClass = HTTPServer
    server_address = ('', port)
    ServerClass(server_address, HandlerClass)
    SimpleHTTPServer.test(HandlerClass, ServerClass)


if __name__ == '__main__':
    test()
