#
# basecgi.py - Base CGI module.
# Copyright (C) 2005  shinGETsu Project.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: basecgi.py,v 1.2 2005/03/12 14:44:46 fuktommy Exp $
#

import os
import sys

import config

__version__ = "$Revision: 1.2 $"


class CGI:

    """Base CGI class.

    start(): start the CGI.
    run(): main routine for CGI.

    """

    stdin = sys.stdin
    stdout = sys.stdout
    stderr = sys.stderr
    environ = os.environ

    def start(self):
        """Start the CGI."""
        try:
            self.run()
        except IOError:
            pass

    def run(self):
        """Main routine for CGI."""
        pass

    def path_info(self):
        """Parse PATH_INFO."""
        if "PATH_INFO" in os.environ:
            path = os.environ["PATH_INFO"]
            if path.startswith("/"):
                path = path[1:]
        else:
            path = ""
        return path

    def header(self, content="text/plain", addtional=None):
        self.stdout.write("Content-Type: " + content + "\n")
        if addtional is not None:
            for k in addtional:
                self.stdout.write(k + ": " + str(addtional[k]) + "\n")
        self.stdout.write("\n")
