#
# httpd.py - Tiny HTTP server running in another thread.
# Copyright (C) 2005  shinGETsu Project.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: httpd.py,v 1.8 2005/03/13 15:13:55 fuktommy Exp $
#

import os
import threading
import BaseHTTPServer
import SimpleHTTPServer

import config
import _CGIHTTPServer

__version__ = "$Revision: 1.8 $"

class Httpd(threading.Thread):

    """Tiny HTTP server running in another thread."""

    daemon = None

    def __init__(self):
        threading.Thread.__init__(self)
        HandlerClass = _CGIHTTPServer.HTTPRequestHandler
        ServerClass = _CGIHTTPServer.HTTPServer
        server_address = ("", config.port)
        HandlerClass.server_version = config.version
        HandlerClass.root_index = config.gateway
        self.daemon = ServerClass(server_address, HandlerClass)

    def run(self):
        os.chdir(config.docroot)
        self.daemon.serve_forever()
